﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Insteon.Messages.Insteon
{
    //#02 #50 #14 

    internal class ButtonEventReportMessage : Message
    {
        internal const int MessCommand = 0x54;
        internal const int MessLength = 3;

        internal readonly byte Group;
        internal readonly byte Command;
        internal readonly ButtonEvent ButtonEvent;

        public ButtonEventReportMessage(byte[] buffer, UInt16 Length, UInt64 Number, out UInt16 Size)
            : base(buffer, Length, Number)
        {
            if (!Check(buffer, Length))
            {
                throw new Exception("Invalid message format");
            }

            ButtonEvent = (ButtonEvent) Enum.ToObject(typeof(ButtonEvent), buffer[2]);
            Size = MessLength;
        }

        internal static bool Check(byte[] buffer, UInt16 length)
        {
            if ((length >= MessLength) && (buffer[1] == MessCommand))
            {
                return true;
            }
            else
            {
                return false;
            }
        }
    }
}
