﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Insteon.Messages.Insteon
{
    internal class StartAllLinkResponse : Message
    {
        internal const int MessCommand = 0x64;
        internal const int MessLength = 5;

        internal readonly byte LinkCode;
        internal readonly byte Group;
        internal readonly ResponseStatus Status;

        public StartAllLinkResponse(byte[] buffer, UInt16 Length, UInt64 Number, out UInt16 Size)
            : base(buffer, Length, Number)
        {
            if (!Check(buffer, Length))
            {
                throw new Exception("Invalid message format");
            }
            LinkCode = (byte) new LinkCode(buffer[2]).Value;     
            Status = new ResponseStatus(buffer[4]);
            Group = buffer[3];
            Size = MessLength;
        }

        internal static bool Check(byte[] buffer, UInt16 length)
        {
            if ((length >= MessLength) && (buffer[1] == MessCommand))
            {
                return true;
            }
            else
            {
                return false;
            }
        }
    }
}
